// Class declaration file: ordercol.h

#ifndef ORDERCOL_H

#include <iostream.h>
#include "apvector.h"

template <class itemType> class ordered_collection
{
	public:

	// Constructors

	ordered_collection();
	ordered_collection(const ordered_collection<itemType> &oc);

	// Destructor

	~ordered_collection();

	// Assignment

	const ordered_collection<itemType>& operator = 
		(const ordered_collection<itemType> &rhs);

	// Accessor

	int length() const;

	// Indexing	

	itemType operator [ ] (int index) const;
	itemType& operator [ ] (int index);
	
	// Modifiers

	void add_first(const itemType &item);
	void add_last(const itemType &item);
	itemType remove_first();
	itemType remove_last();
	void remove(const itemType &item);

	itemType index_of(const itemType &item);
	ordered_collection<itemType> sort_ascending();
	ordered_collection<itemType> sort_descending();
   
	protected:

	// Data members

	apvector<itemType> myList;
};

//free functions

template <class itemType>
ostream& operator << (ostream &os, const ordered_collection<itemType> &oc);

template <class itemType>
ordered_collection<itemType> operator + (const ordered_collection<itemType> &lhs, const ordered_collection<itemType> &rhs);


#define ORDERCOL_H
#endif
